#include <bindings.dsl.h>
#include <audiofile.h>
#include <af_vfs.h>

module Bindings.AudioFile.VFS where
#strict_import
import System.Posix.Types

#starttype struct _AFvirtualfile
#  field read   , FunPtr (<AFvirtualfile> -> Ptr () -> CSize -> IO CSsize)
#  field length , FunPtr (<AFvirtualfile> -> IO CLong)
#  field write  , FunPtr (<AFvirtualfile> -> Ptr () -> CSize -> IO CSsize)
#  field destroy, FunPtr (<AFvirtualfile> -> IO ())
#  field seek   , FunPtr (<AFvirtualfile> -> CLong -> CInt -> IO CLong)
#  field tell   , FunPtr (<AFvirtualfile> -> IO CLong)
#  field closure, Ptr ()
#stoptype
#synonym_t AFvirtualfile, <_AFvirtualfile>

#ccall af_virtual_file_new         , IO (Ptr <AFvirtualfile>)
#ccall af_virtual_file_new_for_file, Ptr CFile -> IO (Ptr <AFvirtualfile>)
#ccall af_virtual_file_destroy     , Ptr <AFvirtualfile> -> IO ()

#ccall af_fread  , Ptr () -> CSize -> CSize -> Ptr <AFvirtualfile> -> IO CSize
#ccall af_fwrite , Ptr () -> CSize -> CSize -> Ptr <AFvirtualfile> -> IO CSize
#ccall af_fclose , Ptr <AFvirtualfile> -> IO CInt
#ccall af_flength, Ptr <AFvirtualfile> -> IO CLong
#ccall af_fseek  , Ptr <AFvirtualfile> -> CLong -> CInt -> IO CInt
#ccall af_ftell  , Ptr <AFvirtualfile> -> IO CLong
